#if 0
(First of all, I hope you like this neat strategy for placing comments!
This lines are never compiled, because they're "inside" a precompiler
directive that is never true; therefore, they're never compiled!
This is someone else's brilliant idea, but I looove it!)

This program is used to display a changing value in the Status Bar.
This could be used, for example, to display the time. Of course
you can also use "Set Clock Status" to acomplish the same effect.
But what if you want to include an expression based on field values,
Like the Client Code + Name + Phone number?
Well... then you could use this program!

This is not specifically intended to include in applications,
because in applications you can run code whenever you change
from one record to another. This routine will be useful
majorly for end-users operating in VFP.
You can easily specify different intervals between updates
and different expressions.

Credit should be given to Ze Carlos, a fellow co-worker who
uses VFP as an end-user, but is very hungry for knowledge.
His suggestions and questions led me to this program.

How does this operate? Very simple: A timer-based object
is added to the _screen object, and the TIMER event
of that object updates the status bar.

Please, send comments, questions and suggestions
to my e-mail address:
CIS:      100415,175
Internet: 100415.175@compuserve.com

I hope you like it, I do!
#endif


* This is the definition of the default field displayed
#DEFINE DEFAULT_FIELD_DISPLAYED "NOME"

Clear
Wait Window "Initializing..." NoWait
Public cntStatusMessage

* We're going to add the timer-based object to _screen
_screen.addobject( "tmrStatusMessage", "StatusTimer")

* Put some info on VFP's main window
* Save current screen font
Private m.OldFontName
m.OldFontName = _screen.fontname
_screen.fontname = "Courier New"
Text
**********************************************************
***         Placing messages on the Status Bar         ***
**********************************************************
***               Using non-visual classes             ***
**********************************************************
To change the interval between refreshes, type:
_screen.tmrStatusMessage.IntervalBetweenRefreshes = 500

To change the expression evaluated, issue:
_screen.tmrStatusMessage.ValueToDisplay = <cExpression>
where <cExpression> is a character expression, like:
"Name"
or something more complex, like:
"str(c_client, 4)+' '+allt(Prop(Name))+allt(Prop(States.State_Name))"

To terminate all this, issue:
_screen.tmrStatusMessage.Destroy
**********************************************************
EndText

* Restore previous screen font
_screen.fontname = m.OldFontName

?? Chr(7)
Wait Window "Info was placed on your background window. Press [Alt]+[Ctrl]+[Shift] to read it."
* Everything's in place, we'll be now back to the command window.


* Class definition
DEFINE CLASS StatusTimer AS TIMER
	ValueToDisplay = DEFAULT_FIELD_DISPLAYED
	IntervalBetweenRefreshes = 500
	
	Procedure Init
		* This needs to be different from IntervalBetweenRefreshes,
		* So that the Timer method will start using the
		* IntervalBetweenRefreshes parameter value as "Interval"
		This.Interval = 100

	Procedure Timer
		* This variable will be used for the macro substitution
		Private m.ValueStatusMessage
		
		* If the property IntervalBetweenRefreshes was changed,
		* update the Timer's "Interval" property
		If This.IntervalBetweenRefreshes <> This.Interval
			This.Interval = This.IntervalBetweenRefreshes
		EndIf
		
		* If the text displayed in the Status Bar
		* needs to be updated, update it
		m.ValueStatusMessage = This.ValueToDisplay
		If Set( "Message", 1) <> &ValueStatusMessage
			Set Message To &ValueStatusMessage
		EndIf
		
	Procedure Destroy
		* Set the message to the default value; we're exiting...
		Set Message To
ENDDEFINE
